#include <iostream>

using namespace std;

/*..............................................................................#
#																				#
#	An example of probable usage of copy constructor							#
#																				#
#	If you have questions or queries please get back at							#
#																				#
#	rahulnaskar@yahoo.com														#
#...............................................................................#
*/

/*	
	To test the flaw uncomment the following block and comment the block following
	next.
*/

/*
//Class without the copy constructor
//Class where initial memory allocation is done
class clsString
{
private:
	int lenName;	//Length of the string, not required for dynamic memory allocation
	char *strName;	//The string, required to have dynamic memory allocation
public:
	//The constructor where memory is allocated
	clsString(char *s="")
	{
		lenName = strlen(s)+1; 
		strName = new char[lenName]; 
		strcpy(strName,s);
	}
	//Destructor where memory is freed
	~clsString() {cout << "In destructor Name is " << strName << " and length is " << lenName << endl; delete[] strName;}
	//Returns the value where data is stored in allocated memory
	char * getName() {return strName;}
	//Returns the value where data is stored not by allocating memory
	int getLen() {return lenName;}
};
// End: Class without the copy constructor
*/

//Same class written with copy constructor
class clsString
{
private:
	int lenName;	//Length of the string, not required for dynamic memory allocation
	char *strName;	//The string, required to have dynamic memory allocation
public:
	//The constructor where memory is allocated
	clsString(char *s="")
	{
		lenName = strlen(s)+1; 
		strName = new char[lenName]; 
		strcpy(strName,s);
	}
	//The copy constructor
	clsString (const clsString& t)
	{
		cout << "In copy constructor " << endl;
		lenName = t.lenName;
		strName = new char[lenName]; 
		strcpy(strName,t.strName);
	}
	//Destructor where memory is freed
	~clsString() {cout << "In destructor Name is " << strName << " and length is " << lenName << endl; delete[] strName;}
	//Returns the value where data is stored in allocated memory
	char * getName() {return strName;}
	//Returns the value where data is stored not by allocating memory
	int getLen() {return lenName;}
};

int main()
{
	//Explicit initialization
	clsString myName("Bill Gates");
	//Object 1 data
	cout << "Initial Object Name: " << myName.getName() << endl;
	cout << "Initial Object Length: " << myName.getLen() << endl;
	
	//Initialization by existing object
	clsString myDuplName=myName;
	//Object 2 data
	cout << "Copied Object Name: " << myDuplName.getName() << endl;
	cout << "Copied Object Length: " << myDuplName.getLen() << endl;
	cout << "---------------------------" << endl;
	cout << "---------------------------" << endl;
	return 0;
}